export declare enum CloudinaryEvent {
    UPLOAD_PROGRESS_EVENT = "progressChanged"
}
export declare const URL_TYPES: {
    image: any;
    video: any;
    raw: any;
    auto: any;
};
declare type CloudinaryListener = (data: {
    uid: string;
    progress: number;
}) => void;
export declare function setup(options: Record<string, any>): Promise<void>;
export declare type UploadParams = {
    url: string;
    type?: typeof URL_TYPES[keyof typeof URL_TYPES];
    params: {
        preset_name?: string;
    } & Record<string, any>;
};
export declare type CloudinaryUploadResponse = {
    access_mode: string;
    api_key: string;
    asset_id: string;
    bytes: number;
    context: {
        custom: {
            resource_id: string;
            resource_type: string;
        };
    };
    created_at: string;
    etag: string;
    folder: string;
    format: string;
    height: number;
    original_filename: string;
    placeholder: false;
    public_id: string;
    resource_type: string;
    secure_url: string;
    signature: string;
    tags: string[];
    type: string;
    url: string;
    width: number;
};
export declare const cancelUpload: (uid: string) => void;
export declare const upload: (params: UploadParams, onProgress?: CloudinaryListener, onUID?: ((uid: string) => void) | undefined) => Promise<CloudinaryUploadResponse | undefined>;
export {};
